fn main() {
    // These lines wont work bc m1 and m2 are moved
    // let m1 = String::from("Hello");
    // let m2 = String::from("World");
    // greet(m1, m2);
    // let s = format!("{} {}", m1, m2);

    // This is suboptimal
    let m1 = String::from("Hello");
    let m2 = String::from("World");
    let (m1_again, m2_again) = greet_ret(m1, m2);
    let s = format!("{} {}", m1_again, m2_again);
    println!("{s}");

    // stopped here:
    // https://rust-book.cs.brown.edu/ch04-02-references-and-borrowing.html#references-are-non-owning-pointers
}

fn greet(g1: String, g2: String) {
    println!("{} {}!", g1, g2);
}

fn greet_ret(g1: String, g2: String) -> (String, String) {
    println!("{} {}!", g1, g2);
    (g1, g2)
}
